package mongodbtester;


//import com.mongodb.MongoClientOptions;
import com.mongodb.MongoClientURI;
import com.mongodb.MongoClient;
//import com.mongodb.MongoException;
//import com.mongodb.WriteConcern;
import com.mongodb.DB;
//import com.mongodb.client.MongoCollection;
//import com.mongodb.client.MongoDatabase;
import com.mongodb.DBCollection;
import com.mongodb.BasicDBObject;
//import com.mongodb.BasicDBList;
//import com.mongodb.DBObject;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
//import com.mongodb.ServerAddress;
//import java.util.Arrays;


/**
 *
 * @author Claudiu Vinte 
 */
public class MongoDBTester {

    /**
     * @param args the command line arguments
     */

    public static void main(String args[]) {
        try{
            // Conectare la serverul mongodb
            // MongoClient mongoClient = new MongoClient( "localhost" , 27017 );
            MongoClientURI uri = new MongoClientURI("mongodb://bigdata11:bigdata11@cluster0-shard-00-00-qq3hf.mongodb.net:27017,cluster0-shard-00-01-qq3hf.mongodb.net:27017,cluster0-shard-00-02-qq3hf.mongodb.net:27017/test?ssl=true&replicaSet=Cluster0-shard-0&authSource=admin&retryWrites=true");
            
            // Instatiere client mongodb
            MongoClient mongoClient = new MongoClient(uri);
            // Listeaza bazele de date existente pe server
            mongoClient.getDatabaseNames().forEach(System.out::println);
//            MongoDatabase db = mongoClient.getDatabase("test");
            
            // Conectare la o baza de date de pe server
            @SuppressWarnings("deprecation")
			DB db = mongoClient.getDB("BDDB01");
            System.out.println("Connect to database " + db.getName() + " successfully");
            
            // boolean auth = db.authenticate("vinte", "claudiu");
            // System.out.println("Authentication: " + auth);
            
            // Selectare colectie din baza de date
            DBCollection coll = db.getCollection("BDCollection01");      
            System.out.println("Colectia " + coll.getName() + " selectata cu succes");
//            MongoCollection<Document> coll = db.getCollection("coll_simpre_01");
//            System.out.println("Colectia " + coll.getNamespace() + " selectata cu succes");
            
            
//            Document doc = new Document();
            BasicDBObject doc;
            doc = new BasicDBObject("title", "SuperMongoDB").
                    append("description", "database").
                    append("likes", 101).
                    append("url", "http://www.ada.ase.ro/BigData/").
                    append("by", "Claudiu Vinte");
            
			// Inserare document in colectie
//            coll.insertOne(doc);
            coll.insert(doc);
            System.out.println("Document inserat cu succes: " + doc.toString());
            
            // Regasire a tuturor documentelor dintr-o colectie
            System.out.println("Nr. documente in colectia " + coll.getName() + 
                    ": " + coll.getCount());
            DBCursor cursor = coll.find();
            System.out.println("Cursor " + cursor.toString());
            
            int i = 1;
            while (cursor.hasNext()) { 
               System.out.println("Document " + i); 
               System.out.println(cursor.next());      
               i++;
            }
            
            // Regasire document in colectie
            DBObject myDoc = coll.findOne();
            System.out.println("Document: " + myDoc.toString());
            
            // Stergere document din colectie
            coll.remove(myDoc);
            System.out.println("Document " + myDoc.get("_id") + " sters cu succes");
            
        } catch(Exception e) {
            System.err.println( e.getClass().getName() + ": " + e.getMessage() );
        }
    }  
}


